<?php
/**
 * [物料版]重新计算销售物料的店铺冻结数量
 * @author: wangbiao@shopex.cn
 */
error_reporting(E_ALL ^ E_NOTICE);


$domain = $argv[1];
$order_id = $argv[2];
$host_id = $argv[3];

if (empty($domain) || empty($order_id) || empty($host_id)) {
    die('No Params');
}


set_time_limit(0);
require_once(dirname(__FILE__) . '/../../lib/init.php');
cachemgr::init(false);


$db     = kernel::database();

$total   = 0;
$succ    = 0;
$fail    = 0;

$page     = 0;#开始页
$limit    = 500;#每次执行数量

$result    = batch_sales_material_shop_freeze();

ilog('批量更新销售物料店铺冻结已完成', true);

/*
 * 计算销售物料的店铺冻结数量
*
*/
function batch_sales_material_shop_freeze()
{
    global $db, $page, $limit, $fail;
    
    #查询
    $sql    = "SELECT sm_id, shop_id FROM sdb_material_sales_material_shop_freeze WHERE 1 LIMIT ". ($page * $limit) .", " . $limit;
    $dataList    = $db->select($sql);
    
    #没有可执行的货品,则退出.
    if(empty($dataList))
    {
        return false;
    }
    
    #加入事务
    $db->beginTransaction();
    
    foreach ($dataList as $key => $val)
    {
        if(empty($val['sm_id']) || empty($val['shop_id']))
        {
            continue;
        }
        
        #计算店铺冻结数量
        $result    = update_sales_material_shop_freeze($val['shop_id'], $val['sm_id']);
        
        if(!$result)
        {
            $db->rollBack();
            
            $fail++;
            ilog('执行失败...shop_id:'. $val['shop_id'] .', sm_id:'. $val['sm_id'], false);
            
            echo('Warning: UPDATE sdb_material_sales_material_shop_freeze...Error...');
            exit;
        }
    }
    
    #提交事务
    $db->commit();
    
    #release
    unset($dataList, $sql, $result);
    
    $page++;
    usleep(1000000);#暂停一秒
    
    #递归调用
    batch_sales_material_shop_freeze();
}




    /**
     * 重新计算指定的单个销售物料对应的店铺冻结
     * 
     * @param String $shop_id
     * @param Int $product_id
     * @return Boolean
     */
    function update_sales_material_shop_freeze($shop_id, $sm_id)
    {
        global $db;
        
        #先初始化货品对应店铺的冻结数量
        $sql    = "UPDATE sdb_material_sales_material_shop_freeze SET shop_freeze=0 WHERE sm_id=". $sm_id ." AND shop_id='". $shop_id ."'";
        $result    = $db->exec($sql);
        if(!$result)
        {
            return false;
        }
        
        #计算o2o门店未确认收货的订单[注：o2o门店订单收货后才释放店铺冻结数量]
        $o2o_count_num    = 0;
        if(app::get('o2o')->is_installed())
        {
            $o2o_corp_ids   = array();
            $corpObj        = app::get('ome')->model('dly_corp');
            $corp_info      = $corpObj->getList('corp_id', array('d_type'=>2));
            foreach ($corp_info as $key => $val)
            {
                $o2o_corp_ids[]    = $val['corp_id'];
            }
            
            $sql        = "SELECT o.order_id, o.order_bn, o.process_status, o.confirm, j.obj_id, j.obj_type, j.quantity 
                           FROM sdb_ome_order_objects AS j LEFT JOIN sdb_ome_orders AS o ON j.order_id=o.order_id 
                           WHERE o.process_status='splited' AND o.ship_status='0' AND o.status='active' 
                           AND o.shop_id='". $shop_id ."' AND j.goods_id=".$sm_id ." AND o.logi_id in(". implode(',', $o2o_corp_ids) .")";
            $dataList    = $db->select($sql);
            
            if($dataList)
            {
                foreach ($dataList as $key => $val)
                {
                    #获取订单上基础物料信息_过滤掉删除的货品
                    $num    = 0;
                    $sql_item    = "SELECT item_id, product_id, nums, sendnum, item_type FROM sdb_ome_order_items 
                                    WHERE order_id=". $val['order_id'] ." AND obj_id=". $val['obj_id'] ." AND `delete`='false'";
                    $itemRow     = $db->selectrow($sql_item);
                    if(empty($itemRow))
                    {
                        continue;
                    }
                    
                    #销售物料剩余未拆分的数量
                    $diff_num       = intval($itemRow['nums'] - $itemRow['sendnum']);
                    
                    $num    = intval($diff_num / ($itemRow['nums'] / $val['quantity']));
                    if($num)
                    {
                        $o2o_count_num    += $num;#总店铺冻结数量
                    }
                }
            }
        }
        
        #设置店铺冻结数量
        $sql        = "SELECT o.order_id, o.order_bn, o.process_status, o.confirm, j.obj_id, j.obj_type, j.quantity 
                       FROM sdb_ome_order_objects AS j LEFT JOIN sdb_ome_orders AS o ON j.order_id=o.order_id 
                       WHERE o.process_status in ('unconfirmed', 'is_retrial', 'is_declare', 'splitting') AND o.ship_status in('0', '2') 
                       AND o.status='active' AND o.shop_id='". $shop_id ."' AND j.goods_id=".$sm_id;
        $dataList    = $db->select($sql);
        if(empty($dataList))
        {
            #[更新]销售物料店铺冻结
            $sql           = "UPDATE sdb_material_sales_material_shop_freeze SET shop_freeze=". $o2o_count_num ." 
                              WHERE sm_id=". $sm_id ." AND shop_id='". $shop_id ."'";
            $result        = $db->exec($sql);
            if(!$result)
            {
                return false;
            }
            
            return true;
        }
        
        $count_num    = 0;
        foreach ($dataList as $key => $val)
        {
            #订单部分拆分_但未确认状态
            if($val['confirm'] != 'N' && $val['process_status'] != 'splitting')
            {
                continue;//跳过
            }
            
            #获取订单上基础物料信息_过滤掉删除的货品
            $num    = 0;
            $sql_item    = "SELECT item_id, product_id, nums, sendnum, item_type FROM sdb_ome_order_items 
                            WHERE order_id=". $val['order_id'] ." AND obj_id=". $val['obj_id'] ." AND `delete`='false'";
            $itemRow     = $db->selectrow($sql_item);
            if(empty($itemRow))
            {
                continue;
            }
            
            #销售物料剩余未拆分的数量
            if($val['process_status'] == 'splitting')
            {
                #部分拆分时_直接减去发货单上货品数量
                $dly_sql        = "SELECT SUM(number) AS num FROM `sdb_ome_delivery_items_detail` AS did 
                                   JOIN `sdb_ome_delivery` AS d ON d.delivery_id=did.delivery_id 
                                   WHERE did.order_item_id='". $itemRow['item_id'] ."' AND did.product_id='". $itemRow['product_id'] ."' 
                                   AND d.status NOT IN('back', 'cancel', 'return_back') AND d.is_bind='false'";
                $dly_num        = $db->selectrow($dly_sql);
                $diff_num       = intval($itemRow['nums'] - $dly_num['num']);
            }
            else 
            {
                $diff_num       = intval($itemRow['nums'] - $itemRow['sendnum']);
            }
            
            $num    = intval($diff_num / ($itemRow['nums'] / $val['quantity']));
            if($num)
            {
                $count_num    += $num;#总店铺冻结数量
            }
        }
        
        $count_num    = $count_num + $o2o_count_num;#加上O2O店铺冻结数量
        
        #[更新]销售物料店铺冻结
        $sql           = "UPDATE sdb_material_sales_material_shop_freeze SET shop_freeze=". $count_num ." 
                          WHERE sm_id=". $sm_id ." AND shop_id='". $shop_id ."'";
        $result        = $db->exec($sql);
        if(!$result)
        {
            return false;
        }
        
        return true;
    }


/**
 * 日志
 */
function ilog($str, $flag = false)
{
    global $domain;
    $filename = dirname(__FILE__) . '/../logs/recount_sales_material_shop_freeze_' . date('Y-m-d') . '.log';
        
    if($flag)
    {
        $filename = dirname(__FILE__) . '/../logs/recount_sales_material_shop_freeze_' . date('Y-m-d') . '.log';
    }
    
    $fp = fopen($filename, 'a');
    fwrite($fp, date("m-d H:i") . "\t" . $domain . "\t" . $str . "\n");
    fclose($fp);
}
